from Globals import package_home
import os.path

def manage_addDefaultFiles(self, overwrite = 0, REQUEST = None):
    """ Add / regenerate default files for the ZUBB Topic """
    #          name                          file
    files = [('forum_template.pt',          'forum_template.zpt'),
             ('forum.css',                  'forumcss.py'),
             ('index_batch',                'index_batch.py'),
             ('breadcrumb',                 'breadcrumb.py'),

             ('index_html',                 'index_html.zpt'),
             ('forms',                      'forms.zpt'),
             ('message_indent',             'message_indent.zpt'),
             ('message_inline',             'message_inline.zpt'),
             ('post',                       'post.zpt'),
             ('reply',                      'reply.zpt'),
             ('search',                     'search.zpt'),
             ('help_bbcode',                'help_bbcode.zpt'),

             ('skins/email.gif',            'skins/email.gif'),
             ('skins/nt.gif',               'skins/nt.gif'),
             ('skins/icon_folder.gif',      'skins/icon_folder.gif'),
             ('skins/icon_message.gif',     'skins/icon_message.gif'),
             ('skins/forum.css',            'skins/blue/forum.css'),
             ('skins/btn_post.jpg',         'skins/blue/btn_post.jpg'),
             ('skins/btn_reply.jpg',        'skins/blue/btn_reply.jpg'),
             ('skins/btn_search.jpg',       'skins/blue/btn_search.jpg'),
             ('skins/heading_tile.jpg',     'skins/blue/heading_tile.jpg'),
             ('skins/icon_delete.jpg',      'skins/blue/icon_delete.jpg'),
             ('skins/icon_post.jpg',        'skins/blue/icon_post.jpg'),
             ('skins/icon_quote.jpg',       'skins/blue/icon_quote.jpg'),
             ('skins/icon_reply.jpg',       'skins/blue/icon_reply.jpg'),
             ('skins/nav_post.jpg',         'skins/blue/nav_post.jpg'),
             ('skins/nav_reply.jpg',        'skins/blue/nav_reply.jpg'),
             ('skins/nav_search.jpg',       'skins/blue/nav_search.jpg'),
             ('skins/nav_title.jpg',        'skins/blue/nav_title.jpg')
            ]

    if overwrite:
        for name, file in files:
            try:
                container = self
                splitname = name.split('/')
                folders = splitname[:-1]
                name = splitname[-1]
                for folder in folders:
                    container = getattr(container.aq_explicit, folder)
                container.manage_delObjects(ids = [name])
            except:
                pass
    for name, file in files:
        container = self

        # if the object is going in a folder, make the folders
        splitname = name.split('/')
        folders = splitname[:-1]
        name = splitname[-1]
        for newfolder in folders:
            # addFolder only adds if the folder's not there already, so don't worry ;)
            addFolder(container, newfolder)
            container = getattr(container.aq_explicit, newfolder)

        # get extension
        extensions = file.split('.')
        if len(extensions) > 1:
            extension = extensions[-1]
        else:
            extension = ''
        # choose appropriate method
        method = None
        if extension == 'zpt' or extension == 'pt':
            method = addPageTemplate
        elif extension == 'css':
            method = addFile
        elif extension == 'py':
            method = addScript
        elif extension in ('gif', 'jpg', 'png'):
            method = addImage
        # run method
        if method:
            method(container, name, file)
    if REQUEST:
        if overwrite:
            message = "Regenerated and overwrote ZUBB default files."
        else:
            message = "Regenerated ZUBB default files."
        return self.manage_main(self, REQUEST, manage_tabs_message = message)

def getFile(filename):
    # leaves file open - make sure you close it!
    file = '%s/default/%s' % (package_home(globals()), filename)
    return open(file, 'rb')

def addPageTemplate(container, id, file, title = ''):
    # only add if it's not there already
    if not hasattr(container.aq_explicit, id):
        container.manage_addProduct['PageTemplates'].manage_addPageTemplate(id)
        f = getFile(file)
        container[id].write(f.read())
        f.close()
        if title:
            container[id].pt_setTitle(title)

def addFile(container, id, file, title = ''):
    # only add if it's not there already
    if not hasattr(container.aq_explicit, id):
        f = getFile(file)
        container.manage_addProduct['OFSP'].manage_addFile(id, title=title, file=f)
        f.close()
        
def addImage(container, id, file, title = ''):
    # only add if it's not there already
    if not hasattr(container.aq_explicit, id):
        f = getFile(file)
        container.manage_addProduct['OFSP'].manage_addImage(id, title=title, file=f)
        f.close()
        
def addScript(container, id, file, title = ''):
    # only add if it's not there already
    if not hasattr(container.aq_explicit, id):
        container.manage_addProduct['PythonScripts'].manage_addPythonScript(id)
        f = getFile(file)
        container[id].write(f.read())
        f.close()

def addFolder(container, id, title = ''):
    # only add if it's not there already
    if not hasattr(container.aq_explicit, id):
        container.manage_addProduct['OFSP'].manage_addFolder(id, title)
